using Library;
using MySystem.PxcModels;
using System;
using System.Linq;

namespace MySystem
{
    public class UserBackHelper
    {
        public readonly static UserBackHelper Instance = new UserBackHelper();
        private UserBackHelper()
        { }

        public string Start()
        {
            bool op = true;
            WebCMSEntities db = new WebCMSEntities();
            string result = "";
            int total = 0;
            while (op)
            {
                UserBack PopData = new UserBack();
                try
                {
                    //获取apserver待同步的数据，执行入库
                    PopData = RedisDbconn.Instance.RPop<UserBack>("Pop:UserBack");
                    if (PopData != null)
                    {
                        // UserBack checkExist = db.UserBack.FirstOrDefault(m => m.Id == PopData.Id);
                        // if (checkExist != null)
                        // {
                        //     checkExist = PopData;
                        // }
                        // else
                        // {
                            db.UserBack.Add(PopData);
                        // }
                        if (total >= 20)
                        {
                            total = 0;
                            db.SaveChanges();
                        }
                        if (string.IsNullOrEmpty(result)) result = "success";
                    }
                    else
                    {
                        db.SaveChanges();
                        op = false;
                    }
                }
                catch (Exception ex)
                {
                    ErrorMsg msg = new ErrorMsg();
                    msg.Obj = PopData;
                    msg.Time = DateTime.Now;
                    msg.ErrorContent = ex.ToString();
                    function.WriteLog(Newtonsoft.Json.JsonConvert.SerializeObject(msg), "Pop:UserBack:Error");
                    result = "有异常，请查看Pop:UserBack:Error队列";
                }
            }
            db.Dispose();
            return result;
        }
    }
}